//--------------------------------------
// Program Name:
// Author:
// License:
// Description:
//--------------------------------------

/* Keep these headers */
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <tice.h>

/* Standard headers - it's recommended to leave them included */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphx.h>
#include <keypadc.h>
#include <debug.h>
#include <fileioc.h>
#include "gfx/sprites.h"
/* Other available headers */
// stdarg.h, setjmp.h, assert.h, ctype.h, float.h, iso646.h, limits.h, errno.h, debug.h

/* Put your function prototypes here */
void inGameColor();
void lose();
void inGameSprite();
void inGameOriginal();
void inGameEndless();
void menu();
void drawSpriteC();
void drawSpriteO();
void loadHS();
void setHS();
/* Put all your globals here. */
int key, key1, key2, key3, key4, keyPress, stackX = 69, stackY = 208, underColor, timer, drawTimer, drawTimer1 = 75, color, colorSquare = 229, score, highscore, a, x, y;
ti_var_t file;
bool stackLeft, checkPlacement, quit, place = true;
void main(void) {
	gfx_Begin( gfx_8bpp );
	loadHS();
	menu();
	gfx_End();
	pgrm_CleanUp();
}
void loadHS(void) {
	ti_CloseAll();
	file = ti_Open("stackhigh", "r");
	if (file) { 
		ti_Read(&highscore, sizeof(highscore), 1, file);
    }   
    else {
    	highscore = 0;
    }

}
void setHS(void) {
	if (score >= highscore) {
		highscore = score; 
    /* Close all open file handles before we try any funny business */ 
    ti_CloseAll(); 
     
    /* Open a file for writting*/ 
    file = ti_Open("stackhigh", "w"); 
     
    /* write some things to the file */ 
    if (file) 
         ti_Write(&highscore, sizeof(highscore), 1, file);  
	}
}
void inGameColor(void) {
	gfx_FillScreen(color);
	gfx_SetDefaultPalette( gfx_8bpp );
	gfx_SetColor(0);
	gfx_FillRectangle_NoClip(69, 16, 192, 208);
	checkPlacement = false;
	drawTimer1 = 75;
	drawTimer = drawTimer1;
	stackX = 69;
	stackY = 208;
	while (kb_ScanGroup(kb_group_6) != kb_Clear) { 
		if (keyPress % 20 == 0) {
			underColor = gfx_GetPixel(stackX, stackY + 17);
			if (key1 & kb_2nd && underColor != 0) {
				stackY = stackY - 16;
				drawTimer1 = drawTimer1 - 5;
				drawTimer = 0;
				dbg_sprintf(dbgout, "Square UP!\n");
			}
			if (key1 & kb_2nd && underColor == 0)
			  	lose();
			if (stackY <= 15 && underColor !=0) {
				gfx_FillScreen(255);
				gfx_SetTextFGColor(0);
				gfx_PrintStringXY("You Beat The Game!", 110, 1);
				gfx_PrintStringXY("Great Job, 2nd to continue", 90, 10);
				a = 0;
				while (1) {
					a++;
					if (a = 20)
						break;
				}
				while (kb_ScanGroup(kb_group_1) != kb_2nd) { 
				}
				menu();
			}
		}
		if (drawTimer == 0) {
			gfx_SetColor(0);
			gfx_FillRectangle_NoClip(stackX, stackY, 16,16);	
			if (stackX >= 240)
				stackLeft = true;
			if (stackX == 69)
				stackLeft = false;
			if (stackLeft == false) {
				stackX = stackX + 16;
				place = true;
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(stackX, stackY, 16,16);	
			}
			if (stackLeft == true) {
				stackX = stackX - 16;
				place = true;
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(stackX, stackY, 16,16);	
			}
			drawTimer = drawTimer1;
		}
		drawTimer--;
		keyPress++; 
		key2 = kb_ScanGroup(kb_group_6); //Clear
		key = kb_ScanGroup(kb_group_7); //Arrow Keys
  		key1 = kb_ScanGroup(kb_group_1);  //2nd
	}
	lose();
}
void lose(void) {
	gfx_SetDefaultPalette( gfx_8bpp );
	gfx_FillScreen(255);
	gfx_SetTextFGColor(0);
	gfx_PrintStringXY("You Lost", 130, 1);
	while (kb_ScanGroup(kb_group_1) != kb_2nd) {
		if (key & kb_Clear)
			break;
		key = kb_ScanGroup(kb_group_6);
	}
	menu();
}
void inGameSprite(void){
	drawSpriteC();
	stackX = 69;
	stackY = 208;
	checkPlacement = false;
	drawTimer1 = 75;
	drawTimer = drawTimer1;
	while (kb_ScanGroup(kb_group_6) != kb_Clear) { 
		if (keyPress % 20 == 0) {
			underColor = gfx_GetPixel(stackX, stackY + 17); //instead check sprites
			dbg_sprintf(dbgout, "%d\n", underColor);
			if (key1 & kb_2nd && underColor != 59) {
				stackY = stackY - 16;
				drawTimer1 = drawTimer1 - 5;
				drawTimer = 0;
				dbg_sprintf(dbgout, "Square UP!\n");
			}
			if (key1 & kb_2nd && underColor == 59)
			  	lose();
			if (stackY <= 15 && underColor !=0) {
				gfx_FillScreen(255);
				gfx_SetTextFGColor(0);
				gfx_PrintStringXY("You Beat The Game!", 110, 1);
				gfx_PrintStringXY("Great Job, 2nd to continue", 90, 10);
				a = 0;
				while (1) {
					a++;
					if (a = 20)
						break;
				}
				while (kb_ScanGroup(kb_group_1) != kb_2nd) { 
				}
				menu();
			}
		}
		if (drawTimer == 0) {
			gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
			gfx_Sprite_NoClip(blackboardsprite, stackX, stackY);		
			if (stackX >= 240)
				stackLeft = true;
			if (stackX == 69)
				stackLeft = false;
			if (stackLeft == false) {
				stackX = stackX + 16;
				place = true;
				gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
			gfx_Sprite_NoClip(chalksprite, stackX, stackY);
			}
			if (stackLeft == true) {
				stackX = stackX - 16;
				place = true;
				gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
				gfx_Sprite_NoClip(chalksprite, stackX, stackY);
			}
			drawTimer = drawTimer1;
		}
		drawTimer--;
		keyPress++; 
		key2 = kb_ScanGroup(kb_group_6); //Clear
		key = kb_ScanGroup(kb_group_7); //Arrow Keys
  		key1 = kb_ScanGroup(kb_group_1);  //2nd
	}
	lose();
}

void inGameOriginal(void) {
	drawSpriteO();
	stackX = 69;
	stackY = 208;
	checkPlacement = false;
	drawTimer1 = 75;
	drawTimer = drawTimer1;
	while (kb_ScanGroup(kb_group_6) != kb_Clear) { 
		if (keyPress % 20 == 0) {
			underColor = gfx_GetPixel(stackX, stackY + 17); //instead check sprites
			dbg_sprintf(dbgout, "%d\n", underColor);
			if (key1 & kb_2nd && underColor != 29) {
				stackY = stackY - 16;
				drawTimer1 = drawTimer1 - 5;
				drawTimer = 0;
				dbg_sprintf(dbgout, "Square UP!\n");
			}
			if (key1 & kb_2nd && underColor == 29)
			  	lose();
			if (stackY <= 15 && underColor !=0) {
				gfx_FillScreen(255);
				gfx_SetTextFGColor(0);
				gfx_PrintStringXY("You Beat The Game!", 110, 1);
				gfx_PrintStringXY("Great Job, 2nd to continue", 90, 10);
				a = 0;
				while (1) {
					a++;
					if (a = 20)
						break;
				}
				while (kb_ScanGroup(kb_group_1) != kb_2nd) { 
				}
				menu();
			}
		}
		if (drawTimer == 0) {
			gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
			gfx_Sprite_NoClip(stackBG, stackX, stackY);		
			if (stackX >= 240)
				stackLeft = true;
			if (stackX == 69)
				stackLeft = false;
			if (stackLeft == false) {
				stackX = stackX + 16;
				place = true;
				gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
			gfx_Sprite_NoClip(stackblock, stackX, stackY);
			}
			if (stackLeft == true) {
				stackX = stackX - 16;
				place = true;
				gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
				gfx_Sprite_NoClip(stackblock, stackX, stackY);
			}
			drawTimer = drawTimer1;
		}
		drawTimer--;
		keyPress++; 
		key2 = kb_ScanGroup(kb_group_6); //Clear
		key = kb_ScanGroup(kb_group_7); //Arrow Keys
  		key1 = kb_ScanGroup(kb_group_1);  //2nd
	}
	lose();
}
void menu(void) {
	if (score > highscore)
		setHS();
	gfx_SetDefaultPalette( gfx_8bpp );
	gfx_FillScreen(color);
	gfx_SetTextFGColor(232);
	gfx_PrintStringXY("StackerCE", 130, 1);
	gfx_SetTextFGColor(112);
	gfx_PrintStringXY("1. Play in Color", 110, 10);
	gfx_PrintStringXY("2. Play Original", 110, 20);
	gfx_PrintStringXY("3. Play Custom Sprites", 90, 30);
	gfx_PrintStringXY("4. Play Endless", 113, 40);
	gfx_PrintStringXY("Up/Down fo Custom Colors", 70, 50);
	gfx_PrintStringXY("Clear to exit", 120, 60);
	gfx_PrintStringXY("Highscore:", 107, 80);
	gfx_SetTextXY(195, 80);
	gfx_PrintInt(highscore, 3);
	gfx_SetColor(colorSquare);
	gfx_FillRectangle_NoClip(140, 110, 48, 48);
	while (kb_ScanGroup(kb_group_6) != kb_Clear) {
		if (keyPress % 17 == 0) {
			if (key & kb_Right) {
				if (colorSquare == 254)
					colorSquare = 255;
				colorSquare++;
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(140, 110, 48, 48);
			}
			if (key & kb_Left) {
				if (colorSquare == 254)
					colorSquare = 255;
				colorSquare--;
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(140, 110, 48, 48);
			}
			if (key & kb_Down) {
				color++;
				gfx_FillScreen(color);
				gfx_SetTextFGColor(232);
				gfx_PrintStringXY("StackerCE", 130, 1);
				gfx_SetTextFGColor(112);
				gfx_PrintStringXY("1. Play in Color", 110, 10);
				gfx_PrintStringXY("2. Play Original", 110, 20);
				gfx_PrintStringXY("3. Play Custom Sprites", 90, 30);		
				gfx_PrintStringXY("4. Play Endless", 113, 40);
				gfx_PrintStringXY("Up/Down fo Custom Colors", 70, 50);
				gfx_PrintStringXY("Clear to exit", 120, 60);
				gfx_PrintStringXY("Highscore:", 107, 80);
				gfx_SetTextXY(195, 80);
				gfx_PrintInt(highscore, 3);
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(140, 110, 48, 48);
			}
			if (key & kb_Up) {
				color--;
				gfx_FillScreen(color);
				gfx_SetTextFGColor(232);
				gfx_PrintStringXY("StackerCE", 130, 1);
				gfx_SetTextFGColor(112);
				gfx_PrintStringXY("1. Play in Color", 110, 10);
				gfx_PrintStringXY("2. Play Original", 110, 20);
				gfx_PrintStringXY("3. Play Custom Sprites", 90, 30);		
				gfx_PrintStringXY("4. Play Endless", 113, 40);
				gfx_PrintStringXY("Up/Down fo Custom Colors", 70, 50);
				gfx_PrintStringXY("Clear to exit", 120, 60);
				gfx_PrintStringXY("Highscore:", 107, 80);
				gfx_SetTextXY(195, 80);
				gfx_PrintInt(highscore, 3);
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(140, 110, 48, 48);
			}
			if (key1 & kb_1)
				inGameColor();
			if (key3 & kb_2)
				inGameOriginal();
			if (key4 & kb_3)
				inGameSprite();
			if (key1 & kb_4)
				inGameEndless();
			}
		keyPress++;
		key2 = kb_ScanGroup(kb_group_6); //Clear
		key = kb_ScanGroup(kb_group_7); //Arrow Keys
  		key1 = kb_ScanGroup(kb_group_3);  //1, 4
  		key3 = kb_ScanGroup(kb_group_4); //2
  		key4 = kb_ScanGroup(kb_group_5); //3
	}
}
void drawSpriteC(void) {
	gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
	x = 0;
	y = 0;
	while (1) {
		gfx_Sprite_NoClip(woodborder,x,y);
		x = x+16;
		if (x >= 320) {
			y = y + 16;
			x = 0;
		}
		if (y >= 240)
			break;
	}
	x = 69;
	y = 16;
	while (1) {
		gfx_Sprite_NoClip(blackboardsprite, x, y);
		x = x+16;
		if (x >= 256) {
			y = y + 16;
			x = 69;
		}
		if (y >= 224)
			break;
	}
}
void drawSpriteO(void) {
	gfx_FillScreen(124);
	x = 69;
	y = 16;
	gfx_SetPalette( sprites_pal, sizeof(sprites_pal), 0);
	while (1) {
		gfx_Sprite_NoClip(stackBG, x, y);
		x = x+16;
		if (x >= 256) {
			y = y + 16;
			x = 69;
		}
		if (y >= 224)
			break;
	}
}
void inGameEndless(void) {
	gfx_SetDefaultPalette( gfx_8bpp );
	gfx_FillScreen(color);
	gfx_SetColor(0);
	gfx_FillRectangle_NoClip(69, 16, 192, 208);
	checkPlacement = false;
	drawTimer1 = 75;
	drawTimer = drawTimer1;
	score = 0
;	timer = 0;
	stackX = 69;
	stackY = 208;
	while (kb_ScanGroup(kb_group_6) != kb_Clear) { 
		if (keyPress % 20 == 0) {
			underColor = gfx_GetPixel(stackX, stackY + 17);
			if (key1 & kb_2nd && underColor != 0) {
				stackY = stackY - 16;
				drawTimer1 = drawTimer1 - 2;
				drawTimer = 0;
				score++;
				dbg_sprintf(dbgout, "Square UP!\n");
			}
			if (key1 & kb_2nd && underColor == 0)
			  	lose();
			if (stackY <= 15 && underColor !=0) {
				gfx_FillScreen(color);
				gfx_SetColor(0);
				stackY = 208;
				drawTimer = 0;
				drawTimer1 = drawTimer1 - 2;
				gfx_FillRectangle_NoClip(69, 16, 192, 208);
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(stackX, stackY, 16,16);
				stackY = stackY - 16;
				checkPlacement = false;
			}
		}
		if (drawTimer == 0) {
			gfx_SetColor(0);
			gfx_FillRectangle_NoClip(stackX, stackY, 16,16);	
			if (stackX >= 240)
				stackLeft = true;
			if (stackX == 69)
				stackLeft = false;
			if (stackLeft == false) {
				stackX = stackX + 16;
				place = true;
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(stackX, stackY, 16,16);	
			}
			if (stackLeft == true) {
				stackX = stackX - 16;
				place = true;
				gfx_SetColor(colorSquare);
				gfx_FillRectangle_NoClip(stackX, stackY, 16,16);	
			}
			drawTimer = drawTimer1;
		}
		drawTimer--;
		keyPress++; 
		key2 = kb_ScanGroup(kb_group_6); //Clear
		key = kb_ScanGroup(kb_group_7); //Arrow Keys
  		key1 = kb_ScanGroup(kb_group_1);  //2nd
	}
	lose();
}
/* Put other functions here */
